/*
 * location.h - Source code location of language elements
 *
 * Written 2001 by Werner Almesberger
 * Copyright 2001 EPFL-ICA, Network Robots
 */

/*
 * Note: in the future, we may even try to include column information, like
 * recent versions of gcc do, so users of location.h should treat LOCATION
 * as an abstract data type.
 */


#ifndef LOCATION_H
#define LOCATION_H

#include <stdio.h>


typedef struct {
    const char *file;
    const char *tag;
    int line;
} LOCATION;


extern char *file_name;
extern int lineno;


void input_file(const char *name);
LOCATION current_location(void);
int print_location(FILE *file,LOCATION loc);
int print_current_location(FILE *file_name);

void write_location_map(const char *file_name);

#endif /* LOCATION_H */
